// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from four_wheel_steering_msgs:msg/FourWheelSteering.idl
// generated code does not contain a copyright notice

#include "four_wheel_steering_msgs/msg/detail/four_wheel_steering__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_four_wheel_steering_msgs
const rosidl_type_hash_t *
four_wheel_steering_msgs__msg__FourWheelSteering__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x14, 0x31, 0xac, 0xb6, 0x38, 0x40, 0xf4, 0x2e,
      0x50, 0x6a, 0xa3, 0x35, 0x2e, 0xc5, 0x4d, 0xd0,
      0xf8, 0x91, 0xfd, 0x47, 0xb7, 0x4e, 0x28, 0xc6,
      0x57, 0x0d, 0x71, 0xd0, 0x7b, 0x7c, 0xeb, 0xc1,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char four_wheel_steering_msgs__msg__FourWheelSteering__TYPE_NAME[] = "four_wheel_steering_msgs/msg/FourWheelSteering";

// Define type names, field names, and default values
static char four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__front_steering_angle[] = "front_steering_angle";
static char four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__rear_steering_angle[] = "rear_steering_angle";
static char four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__front_steering_angle_velocity[] = "front_steering_angle_velocity";
static char four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__rear_steering_angle_velocity[] = "rear_steering_angle_velocity";
static char four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__speed[] = "speed";
static char four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__acceleration[] = "acceleration";
static char four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__jerk[] = "jerk";

static rosidl_runtime_c__type_description__Field four_wheel_steering_msgs__msg__FourWheelSteering__FIELDS[] = {
  {
    {four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__front_steering_angle, 20, 20},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__rear_steering_angle, 19, 19},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__front_steering_angle_velocity, 29, 29},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__rear_steering_angle_velocity, 28, 28},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__speed, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__acceleration, 12, 12},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {four_wheel_steering_msgs__msg__FourWheelSteering__FIELD_NAME__jerk, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
four_wheel_steering_msgs__msg__FourWheelSteering__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {four_wheel_steering_msgs__msg__FourWheelSteering__TYPE_NAME, 46, 46},
      {four_wheel_steering_msgs__msg__FourWheelSteering__FIELDS, 7, 7},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "## Driving command or odometry msg for a FourWheelSteering vehicle.\n"
  "#  $Id$\n"
  "\n"
  "# Assumes FourWheelSteering with front-wheel and rear-wheel steering. The left\n"
  "# and right front wheels are generally at different angles. To simplify,\n"
  "# the commanded angle corresponds to the yaw of a virtual wheel located at the\n"
  "# center of the front or rear axle, like on a tricycle.  Positive yaw is to\n"
  "# the left. (This is *not* the angle of the steering wheel inside the\n"
  "# passenger compartment.)\n"
  "#\n"
  "# Zero steering angle velocity means change the steering angle as\n"
  "# quickly as possible. Positive velocity indicates an absolute\n"
  "# rate of change either left or right.\n"
  "#\n"
  "float32 front_steering_angle           # position of the virtual angle (radians)\n"
  "float32 rear_steering_angle            # position of the virtual angle (radians)\n"
  "float32 front_steering_angle_velocity  # rate of change (radians/s)\n"
  "float32 rear_steering_angle_velocity   # rate of change (radians/s)\n"
  "\n"
  "# Speed, acceleration and jerk (the 1st, 2nd and 3rd\n"
  "# derivatives of position). All are measured at the vehicle's\n"
  "# center of the rear axle.\n"
  "#\n"
  "# Speed is the scalar magnitude of the velocity vector.\n"
  "# The speed value is the norm of the velocity component in x (longitudinal) \n"
  "# and y (lateral) direction\n"
  "# Direction is forward unless the sign is negative, indicating reverse.\n"
  "# If the steering angle are equal to +/- pi/2, then the direction is left\n"
  "# unless the sign is negative, indicating right.\n"
  "#\n"
  "# Zero acceleration means change speed as quickly as\n"
  "# possible. Positive acceleration indicates an absolute\n"
  "# magnitude; that includes deceleration.\n"
  "#\n"
  "# Zero jerk means change acceleration as quickly as possible. Positive\n"
  "# jerk indicates an absolute rate of acceleration change in\n"
  "# either direction (increasing or decreasing).\n"
  "#\n"
  "float32 speed                   # forward speed (m/s)\n"
  "float32 acceleration            # acceleration (m/s^2)\n"
  "float32 jerk                    # jerk (m/s^3)";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
four_wheel_steering_msgs__msg__FourWheelSteering__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {four_wheel_steering_msgs__msg__FourWheelSteering__TYPE_NAME, 46, 46},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 1941, 1941},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
four_wheel_steering_msgs__msg__FourWheelSteering__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *four_wheel_steering_msgs__msg__FourWheelSteering__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
